Subject: Re: [Idr] Question about BGP mandatory attribute missing behavior

From: Rob Shakir <[email-masked]>
Date: Thu, 5 May 2016 17:37:21 -0600

Hi Ajay,

> On 29 Apr, 2016, at 2:08 PM, Ajay L <[email-masked]> wrote:
> 
> The section on NOTIFICATION message says that BGP connection is closed immediately after sending it. So in my scenario, looks like the expected behavior is to send NOTIFICATION message with details of the first detected missing mandatory attribute and close the connection. Please let me know if this interpretation is not correct

An implementation is not expected to send more than one NOTIFICATION message upon encountering an erroneous UPDATE message. Once an error has been encountered, and NOTIFICATION has been transmitted; the sending BGP speaker is expected to close the connection. 

It is worth noting that the error handling behaviour of when NOTIFICATION messages are transmitted was modified by RFC7606. Section 3 of RFC7606 addresses the case of missing well known mandatory fields:

   d.  If any of the well-known mandatory attributes are not present in
       an UPDATE message, then "treat-as-withdraw" MUST be used.  (Note
       that [RFC4760 <https://tools.ietf.org/html/rfc4760>] reclassifies NEXT_HOP as what is effectively
       discretionary.)

i.e., where a speaker is compliant with RFC7606, then NOTIFICATION should not be sent in this scenario.

Kind regards,
r.

---

From: "Smith, Donald" <[email-masked]>
Date: Tue, 10 May 2016 18:05:50 +0000

Where is "well-known" defined?
or well-known mandatory attributes?

01100101000010|10011010111101?
Hint 7 bit ascii
[email-masked]

From: Idr [[email-masked]] on behalf of Rob Shakir [[email-masked]]
Sent: Thursday, May 05, 2016 5:37 PM
To: Ajay L
Cc: [email-masked]
Subject: Re: [Idr] Question about BGP mandatory attribute missing behavior

Hi Ajay,

   d.  If any of the well-known mandatory attributes are not present in
       an UPDATE message, then "treat-as-withdraw" MUST be used.  (Note
       that [RFC4760] reclassifies NEXT_HOP as what is effectively
       discretionary.)

Kind regards,
r.
This communication is the property of CenturyLink and may contain confidential or privileged information. Unauthorized use of this communication is strictly prohibited and may be unlawful. If you have received this communication in error, please immediately notify the sender by reply e-mail and destroy all copies of the communication and any attachments.

---

From: Rob Shakir <[email-masked]>
Date: Tue, 10 May 2016 12:10:51 -0600

> On 10 May, 2016, at 12:05 PM, Smith, Donald <[email-masked]> wrote:
> 

I’n not sure whether this is a serious question: “well-known" is defined based bit 0 of the Attribute Flags field. As per RFC4271.

Mandatory is defined in the same document Section 5.

Kind regards,
r.

---

From: "Smith, Donald" <[email-masked]>
Date: Tue, 10 May 2016 20:54:18 +0000

It was serious. Sorry I googled for it and IETF and couldn't find it.
Thank you for the explanation. I don't know BGP bits by heart I usually have to look them up.

________________________________________
From: Rob Shakir [[email-masked]]
Sent: Tuesday, May 10, 2016 12:10 PM
To: Smith, Donald
Cc: Ajay L; [email-masked]
Subject: Re: [Idr] Question about BGP mandatory attribute missing behavior

Kind regards,
r.